Thanks thanking the wrong edit
Closed, ResolvedPublic

Tokens
"Grey Medal" token, awarded by RandomDSdevel."Cup of Joe" token, awarded by Vachovec1."Cup of Joe" token, awarded by Davey2010."Cup of Joe" token, awarded by Coffee."The World Burns" token, awarded by Liuxinyu970226."The World Burns" token, awarded by Samtar.
Assigned To
Authored By
MusikAnimal, Feb 20 2018

Description

See https://en.wikipedia.org/wiki/Wikipedia:Village_pump_(technical)#Thanks_not_working - (permalink)

When I tried to thank Davey2010 for his edit, it looked as though it went through. I hit refresh on the revision history, and it says I've thanked Begoon for their edit. I tried a second time, and it thanked Begoon's other edit.

It seems it is thanking the most recent non-thanked revision on the page.

My thanks log also shows Begoon was thanked, and not Davey2010.

I'm using Chrome on Mac OS El Capitan, Vector skin.

The thanks button on en.wp has been temporarily hidden to avoid disruption. diff 1 diff 2

Development updated

@Trizek-WMF at 14:50 UTC:

  • All wikis are impacted, whatever the browser/OS; whatever the skin (mobile included)
  • All thanks are shifted: you thank the previous edit, not the current one.
  • Early investigation shows that DOM is correct, but the API is somehow malfunctioning.
  • Developers who can possibly fix have submitted a patch that needs to be reviewed. Thank you for your patience.
There are a very large number of changes, so older changes are hidden. Show Older Changes
MusikAnimal triaged this task as High priority.Feb 20 2018, 1:28 AM
Restricted Application added a project: Collaboration-Team-Triage. · View Herald TranscriptFeb 20 2018, 1:28 AM
Restricted Application added a subscriber: Aklapper. · View Herald Transcript
MusikAnimal updated the task description. (Show Details)Feb 20 2018, 1:29 AM

Maybe this worthy as an Unbreak Now?

MusikAnimal updated the task description. (Show Details)Feb 20 2018, 1:42 AM
MusikAnimal updated the task description. (Show Details)Feb 20 2018, 1:45 AM

Vector skin, Chrome on Windows 7 is also affected, according to Davey2010.

PrimeHunter added a subscriber: PrimeHunter.EditedFeb 20 2018, 2:01 AM


I got the same error in a test with Vector and Firefox. I made two screenshots (combined in one image) for documentation.
I logged in as PrimeHunter3 and viewed https://en.wikipedia.org/w/index.php?title=User_talk:PrimeHunter2&action=history

I thanked PrimeHunter for the 7 September edit, as shown in the first screenshot.
I reloaded the page and the newest 11 October edit by PrimeHunter2 was marked as thanked, as shown in the second screenshot.
PrimeHunter received no thanks. PrimeHunter2 received thanks for the 11 October edit. The thanks log also says PrimeHunter2 was thanked:
https://en.wikipedia.org/w/index.php?title=Special%3ALog&type=thanks&user=PrimeHunter3

MusikAnimal raised the priority of this task from High to Unbreak Now!.Feb 20 2018, 2:23 AM

We've discussed this and believe that this is pretty serious, so upping to UBN. Hope that is okay! We're also going to hide the Thanks link via CSS for the time being.

Restricted Application added subscribers: Liuxinyu970226, Jay8g, TerraCodes. · View Herald TranscriptFeb 20 2018, 2:23 AM
MusikAnimal renamed this task from Thanks thanking for the wrong edit to Thanks thanking the wrong edit.Feb 20 2018, 2:38 AM

MusikAnimal's "We're also going to hide the Thanks link via CSS" refers to adding this to MediaWiki:Common.css in the English Wikipedia:
.mw-thanks-thank-link {display: none;}
Other wikis still have thanks links.

Coffee added a subscriber: Coffee.Feb 20 2018, 8:35 AM

Status update? This is extremely high priority.

Samtar added a subscriber: Samtar.
Nick added a subscriber: Nick.Feb 20 2018, 8:49 AM

Thanks appears to be working correctly on Commons, following a quick test with an edit and an upload.

All developers with experience about this feature are now sleeping. We need to wait a few hours for a fix.

Very quick tests performed before on on the engineers goes to bed seems to show that the problem comes from the API. Thanks are shifted by one: the previous edit is thanked.

I can confirm this bug for cs-wiki. The thanks notification goes to the last user who edited the page. Using Firefox 52.6.0 ESR.

Trizek-WMF updated the task description. (Show Details)

I can confirm this bug for cs-wiki. The thanks notification goes to the last user who edited the page. Using Firefox 52.6.0 ESR.

The bug is on all wikis. I've updated the task accordingly.

All developers with experience about this feature are now sleeping. We need to wait a few hours for a fix.

Very quick tests performed before on on the engineers goes to bed seems to show that the problem comes from the API. Thanks are shifted by one: the previous edit is thanked.

As mentioned above: "Thanks are shifted by one: the previous edit is thanked." appears not quite correct. I tried to thanks User:Vojtasafr here, but the thanks went away to User:Horst (the last user who modified the page at that time), so the difference is +3.

Trizek-WMF updated the task description. (Show Details)Feb 20 2018, 11:23 AM
TheDJ updated the task description. (Show Details)Feb 20 2018, 11:23 AM
Trizek-WMF updated the task description. (Show Details)Feb 20 2018, 11:30 AM
DoRD added a subscriber: DoRD.Feb 20 2018, 1:12 PM

Change 412916 had a related patch set uploaded (by Sbisson; owner: Sbisson):
[mediawiki/extensions/Thanks@master] Send thank for the light link

https://gerrit.wikimedia.org/r/412916

Trizek-WMF updated the task description. (Show Details)Feb 20 2018, 2:50 PM

I have done a few tests by trying to thank lots of people on a page on yue.wp where I don't mind thanking everybody. I can confirm the behaviour described above:

When I click "thank", the thanks always goes to the most recent ''edit'' by a non-bot editor (the most recent edit, not the most recent editor) that hasn't yet been thanked.

KTC added a subscriber: KTC.Feb 20 2018, 3:54 PM
Tbayer added a subscriber: Tbayer.Feb 20 2018, 4:29 PM

Change 412916 merged by jenkins-bot:
[mediawiki/extensions/Thanks@master] Send thank for the right link

https://gerrit.wikimedia.org/r/412916

Change 412971 had a related patch set uploaded (by Catrope; owner: Sbisson):
[mediawiki/extensions/Thanks@wmf/1.31.0-wmf.21] Send thank for the right link

https://gerrit.wikimedia.org/r/412971

Nihlus added a subscriber: Nihlus.Feb 20 2018, 7:53 PM

I'm glad that the button has been disabled as a temporary measure to avoid problems with thanking the wrong users. However, I would like to have the button online and working as soon as possible. I'm finding it bothersome that I can't thank people when I appreciate their efforts.

demon added a subscriber: demon.Feb 20 2018, 10:17 PM

This is fixed in master, just needs a backport (which Roan started already). I'm finishing that now.

Change 412971 merged by jenkins-bot:
[mediawiki/extensions/Thanks@wmf/1.31.0-wmf.21] Send thank for the right link

https://gerrit.wikimedia.org/r/412971

Mentioned in SAL (#wikimedia-operations) [2018-02-20T22:25:57Z] <demon@tin> Synchronized php-1.31.0-wmf.21/extensions/Thanks/modules/ext.thanks.revthank.js: T187757 (duration: 01m 14s)

Ok, this is live now!

Jdforrester-WMF closed this task as Resolved.Feb 20 2018, 10:31 PM
Jdforrester-WMF added a subscriber: Jdforrester-WMF.

Thanks, @demon!

I've undone @MusikAnimal 's hiding of the thank button. Button is now live again and working.

Coffee lowered the priority of this task from Unbreak Now! to Lowest.Feb 20 2018, 10:58 PM
Coffee moved this task from To Triage to Announce in next Tech/News on the User-notice board.
revi raised the priority of this task from Lowest to Unbreak Now!.Feb 20 2018, 10:59 PM

It was Unbreak now! when it was marked as resolved, so I don't think there's any need to change the priority.

Coffee rescinded a token.Feb 20 2018, 11:06 PM
Coffee awarded a token.

It was Unbreak now! when it was marked as resolved, so I don't think there's any need to change the priority.

Roger that... didn't know if it still showed up in the UN list or whatnot.

Davey2010 awarded a token.EditedFeb 20 2018, 11:09 PM

Not sure if I can or should comment here but just wanted to say thanks all for fixing this,

Jamez42 removed a subscriber: Jamez42.Feb 21 2018, 1:44 AM

It was Unbreak now! when it was marked as resolved, so I don't think there's any need to change the priority.

Roger that... didn't know if it still showed up in the UN list or whatnot.

@Coffee, a closed task will not appear in UBN open tasks' list. :)

Not sure if I can or should comment here but just wanted to thanks all for fixing this,

That kind of feedback is rare but very much appreciated. Thanks @Davey2010!

Vachovec1 awarded a token.

You have also my thanks for the status updates and the prompt fix.